//
// $Id: Payload_Receiver.h 76591 2007-01-25 18:17:52Z elliott_c $
//

#ifndef BIG_REQUEST_MUXING_PAYLOAD_RECEIVER_H
#define BIG_REQUEST_MUXING_PAYLOAD_RECEIVER_H
#include /**/ "ace/pre.h"

#include "TestS.h"

/// Implement the Test::Payload_Receiver interface
/**
 * Simply print count how many bytes were received.
 */
class Payload_Receiver
  : public virtual POA_Test::Payload_Receiver
{
public:
  Payload_Receiver ();

  // = The skeleton methods
  virtual void more_data (const Test::Payload &payload)
    ACE_THROW_SPEC ((CORBA::SystemException));

  virtual void sync_none_more_data (const Test::Payload &payload)
    ACE_THROW_SPEC ((CORBA::SystemException));

  int count(bool sync_none = false) const;

private:
  ACE_Atomic_Op<TAO_SYNCH_MUTEX, int> message_count_;
  ACE_Atomic_Op<TAO_SYNCH_MUTEX, int> sync_none_message_count_;
};

#include /**/ "ace/post.h"
#endif /* BIG_REQUEST_MUXING_PAYLOAD_RECEIVER_H */
